
// Arkanoid Like.
// Code: 17o2!!
// Contact: Clement CORDE, c1702@yahoo.com

// Credits for the material used here:
//
// Some of the graphics were ripped from the ST version.
// Backgrounds taken from the StrategyWiki online arcade screenshots (http://strategywiki.org/wiki/Arkanoid/Walkthrough).
// This means some of the graphics are probably the property of Taito.
// As there is no profit intended, I hope I won't get sewed.
//
// Font found on Daniel Guldkrans's website (http://www.algonet.se/~guld1/freefont.htm), and slightly retouched by me.
//
// All additional graphics by me.
//


#include "includes.h"


// Variables gnrales.
struct SGene gVar;
struct SExg gExg;

#define min(a, b) (((a)<(b))?(a):(b))
#define max(a, b) (((a)>(b))?(a):(b))


// Gestionnaire d'vnements.
int EventHandler(u32 nInGame)
{
	SDL_Event event;
	static u32	nLastPhase;

	while (SDL_PollEvent(&event))
	{
		switch (event.type)
		{
		case SDL_KEYDOWN:
			if (gVar.pKeys[SDLK_ESCAPE]) return (1);	// Emergency exit.

			// Toggle fullscreen/windowed.
			if (gVar.pKeys[SDLK_F10])
			{
				gRender.nFullscreenMode ^= 1;
				Render_SetVideoMode();
				// Replace la souris  l'endroit du joueur.
				if (nInGame) SDL_WarpMouse(gBreak.nPlayerPosX, gBreak.nPlayerPosY);		// => Gnre un event.
			}
			// Toggle render mode.
			if (gVar.pKeys[SDLK_F9])
			{
				if (++gRender.nRenderMode >= e_RenderMode_MAX) gRender.nRenderMode = 0;
				Render_SetVideoMode();
				//
				if (gBreak.nPhase == e_Game_Pause) SDL_FillRect(gVar.pScreen, NULL, CLR_BLACK_IDX);		// Solution de facilit, si chgt de rsolution en pause, cran noir. (Mieux que bug).
			}

			// Gestion de la pause. Ctrl sur Pandora
			if (nInGame == 1 && (gVar.pKeys[SDLK_p] || gVar.pKeys[SDLK_LCTRL]))
			{
				if (gBreak.nPhase == e_Game_Pause)
				{
					gBreak.nPhase = nLastPhase;			// On sort de la pause.
					SDL_ShowCursor(SDL_DISABLE);		// Cache le pointeur de la souris.
					// Replace la souris  l'endroit du joueur.
					SDL_WarpMouse(gBreak.nPlayerPosX, gBreak.nPlayerPosY);		// => Gnre un event.
				}
				else
				{
					// On passe en pause.
					nLastPhase = gBreak.nPhase;
					gBreak.nPhase = e_Game_Pause;

					// Affichage du texte de pause.
					char	*pStrPause = "PAUSE";
					u32 i = Font_Print(0, 10, pStrPause, FONT_NoDisp);	// Pour centrage.
					Font_Print((SCR_Width / 2) - (i / 2), 123, pStrPause, 0);
					SprDisplayAll();

					SDL_ShowCursor(SDL_ENABLE);		// Affiche le pointeur de la souris.
				}
			// Emulate mouse with DPad, X (and shoulder as faster L/R)
			}

			if (gVar.pKeys[SDLK_PAGEDOWN] || gVar.pKeys[SDLK_HOME])
			{
				gVar.nMouseButtons |= MOUSE_BtnLeft;
			}
			if (event.key.keysym.sym == SDLK_UP)
				gVar.nKeyUp=1;
			if (event.key.keysym.sym == SDLK_DOWN)
				gVar.nKeyDown=1;
			if (event.key.keysym.sym == SDLK_LEFT)
				gVar.nKeyLeft=1;
			if (event.key.keysym.sym == SDLK_RIGHT)
				gVar.nKeyRight=1;
			if (event.key.keysym.sym == SDLK_RSHIFT)
				gVar.nKeyFastLeft=2;
			if (event.key.keysym.sym == SDLK_RCTRL)
				gVar.nKeyFastRight=2;

			break;

		case SDL_KEYUP:
			if (event.key.keysym.sym == SDLK_UP)
				gVar.nKeyUp=0;
			if (event.key.keysym.sym == SDLK_DOWN)
				gVar.nKeyDown=0;
			if (event.key.keysym.sym == SDLK_LEFT)
				gVar.nKeyLeft=0;
			if (event.key.keysym.sym == SDLK_RIGHT)
				gVar.nKeyRight=0;
			if (event.key.keysym.sym == SDLK_RSHIFT)
				gVar.nKeyFastLeft=0;
			if (event.key.keysym.sym == SDLK_RCTRL)
				gVar.nKeyFastRight=0;
			break;

		case SDL_MOUSEMOTION:
			gVar.nMousePosX = event.motion.x;
			gVar.nMousePosY = event.motion.y;
			break;

		case SDL_MOUSEBUTTONDOWN:
			switch (event.button.button)
			{
			case SDL_BUTTON_LEFT:
				gVar.nMouseButtons |= MOUSE_BtnLeft;
				break;

			default:
				break;
			}

			break;

		case SDL_QUIT:		// Fermeture de la fentre.
			exit(0);
			break;
		}
	}
	return (0);
}


// Cration de la palette :
// On recopie dans la palette gnrale la partie de palette correspondant au dcor + la palette des sprites.
void SetPalette(SDL_Surface *pBkg, SDL_Color *pSprPal, u32 nSprPalIdx)
{
	u32	i;
	SDL_Color	*pSrcPal = pBkg->format->palette->colors;

	// Couleurs du dcor.
	for (i = 0; i < nSprPalIdx; i++)
	{
		gVar.pColors[i] = pSrcPal[i];
	}

	// Couleurs des sprites.
	for (; i < 256; i++)
	{
		gVar.pColors[i] = pSprPal[i - SPR_Palette_Idx];
	}

	// Palette logique.
	SDL_SetPalette(gVar.pScreen, SDL_LOGPAL, gVar.pColors, 0, 256);		// Sur gVar.pScreen car c'est la surface de rendu.

}



// Le Menu (gnrique).
u32 Menu(void (*pFctInit)(void), u32 (*pFctMain)(void))
{
	u32	nMenuVal = MENU_Null;

	SDL_FillRect(gVar.pScreen, NULL, CLR_BLACK_IDX);	// Clear screen.
	RenderFlip(0);
	Fade(0);

	gVar.pBackground = gVar.pBkg[0];		// Dcor par dfaut.
	gVar.pBkgRect = NULL;					// Par dfaut, NULL (toute la surface).

	(*pFctInit)();		// Menu, Init fct.
	// Sets up palette.
	SetPalette(gVar.pBackground, gVar.pSprColors, SPR_Palette_Idx);

	// Main loop.
	FrameInit();
	while (nMenuVal == MENU_Null)
	{
		// Gestion des venements.
		gVar.nMouseButtons = 0;		// Raz mouse buttons.
		//EventHandler();
		if (EventHandler(0) != 0) { nMenuVal = MENU_Quit; break; }

		SDL_BlitSurface(gVar.pBackground, gVar.pBkgRect, gVar.pScreen, NULL);	// Recopie le dcor.
		nMenuVal = (*pFctMain)();	// Menu, Main fct.
		SprDisplayAll();

		RenderFlip(1);		// Wait for frame, Flip.
		Fade(gVar.nFadeVal);
	}

	return (nMenuVal);
}

// La boucle de jeu.
void Game(void)
{


	// Cinmatique d'intro.
//todo:...


	SDL_FillRect(gVar.pScreen, NULL, CLR_BLACK_IDX);	// Clear screen.
	RenderFlip(0);
	Fade(0);

	// Init.
	ExgBrkInit();
	// Sets up palette (Mme palette pour tous les niveaux).
	SetPalette(gVar.pLev[0], gVar.pSprColors, SPR_Palette_Idx);
	//>> (Mettre le fader ?)
	gVar.nFadeVal = 256;
	Fade(gVar.nFadeVal);					// Remet la palette physique.
	//<<

	// Main loop.
	FrameInit();
	while (gExg.nExitCode == 0)
	{
		// Gestion des venements.
		gVar.nMouseButtons = 0;		// Raz mouse buttons.
		//EventHandler();
		if (EventHandler(1) != 0) break;

		if (gBreak.nPhase != e_Game_Pause)
		{
			SDL_BlitSurface(gVar.pLevel, NULL, gVar.pScreen, NULL);		// Copie de l'image de fond.
			Breaker();
			SprDisplayAll();
		}
		RenderFlip(1);	// Wait for frame, Flip.

		//Fade(gVar.nFadeVal);
	}
	SDL_ShowCursor(SDL_DISABLE);		// Cache le pointeur de la souris, au cas ou on quitte pendant la pause.


	// Si jeu termin, cinmatique de fin.
//	if (gExg.nExitCode == e_Game_AllClear) {}
//todo:...


	// High score ?
	if (gExg.nExitCode == e_Game_GameOver || gExg.nExitCode == e_Game_AllClear)
	{
		if (Scr_CheckHighSc(gExg.nScore) >= 0)
		{
			// Saisie du nom.
			Menu(MenuGetName_Init, MenuGetName_Main);
			// Affichage de la table des high scores.
			Menu(MenuHighScores_Init, MenuHighScores_Main);
		}
	}

}


// Point d'entre.
int main(int argc, char *argv[])
{
	u32	nLoop;
	u32	nMenuVal;
	u32	i;

	assert(MstCheckStructSizes() == 0);		// Debug : Vrifie la taille des structures spcifiques des monstres.

	// SDL Init.
	if (SDL_Init(SDL_INIT_VIDEO) < 0) {
		fprintf(stderr, "Unable to init SDL: %s\n", SDL_GetError());
		exit(1);
	}
	// atexit : Quand on quittera (exit, return...), SDL_Quit() sera appele.
	atexit(SDL_Quit);

	// Video mode init.
	Render_InitVideo();
	SDL_WM_SetCaption("Arkanoid by 17o2!!", NULL);	// Nom de la fentre.
	gRender.nRenderMode = e_RenderMode_Scale2x;
	Render_SetVideoMode();

	gVar.pKeys = SDL_GetKeyState(NULL);		// Init ptr kb.

	// Preca Sinus et Cosinus.
	PrecaSinCos();

	// Load sprites.
	SprInitEngine();
	SprLoadBMP("gfx/bricks.bmp", gVar.pSprColors, SPR_Palette_Idx);
	SprLoadBMP("gfx/font_small.bmp", NULL, 0);

	// Load levels backgound pictures.
	char	*pBkgLevFilenames[GFX_NbBkg] = { "gfx/lev1.bmp", "gfx/lev2.bmp", "gfx/lev3.bmp", "gfx/lev4.bmp", "gfx/levdoh.bmp" };
	for (i = 0; i < GFX_NbBkg; i++)
	{
		if ((gVar.pLev[i] = SDL_LoadBMP(pBkgLevFilenames[i])) == NULL) {
			fprintf(stderr, "Couldn't load picture '%s' : %s\n", pBkgLevFilenames[i], SDL_GetError());
			exit(1);
		}
	}
	gVar.pLevel = gVar.pLev[0];

	// Load menus backgound pictures.
	char	*pBkgMenFilenames[MENU_NbBkg] = { "gfx/bkg1.bmp", "gfx/bkg2.bmp" };
	for (i = 0; i < MENU_NbBkg; i++)
	{
		if ((gVar.pBkg[i] = SDL_LoadBMP(pBkgMenFilenames[i])) == NULL) {
			fprintf(stderr, "Couldn't load picture '%s' : %s\n", pBkgMenFilenames[i], SDL_GetError());
			exit(1);
		}
	}
	gVar.pBackground = gVar.pBkg[0];

	// Init sound.
	Sfx_SoundInit();
	Sfx_LoadWavFiles();
	Sfx_SoundOn();	// Starts playback.

	//
	MenuInit();
	// Lecture de la table des high-scores.
	Scr_Load();

	SDL_ShowCursor(SDL_DISABLE);	// Cache le pointeur de la souris.

	// Boucle infinie.
	nMenuVal = MENU_Main;//MENU_Game;
	nLoop = 1;
	while (nLoop)
	{
		switch (nMenuVal)
		{
		case MENU_Main :	// Main menu.
			nMenuVal = Menu(MenuMain_Init, MenuMain_Main);
			break;

		case MENU_Game :	// Jeu.
			Game();
			nMenuVal = MENU_Main;
			break;

		case MENU_HallOfFame :	// High scores.
			Menu(MenuHighScores_Init, MenuHighScores_Main);
			nMenuVal = MENU_Main;
			break;

		case MENU_Quit :	// Sortie.
			nLoop = 0;
			break;
		}

	}


	SDL_ShowCursor(1);		// Rautorise l'affichage du curseur de la souris.

	Sfx_SoundOff();	// Stops playback.
	Sfx_FreeWavFiles();	// Libre les ressources des fx.

	// Libre les ressources des sprites.
	SprRelease();

	// Free the allocated surfaces.
	for (i = 0; i < GFX_NbBkg; i++)
	{
		SDL_FreeSurface(gVar.pLev[i]);
	}
	for (i = 0; i < MENU_NbBkg; i++)
	{
		SDL_FreeSurface(gVar.pBkg[i]);
	}

	// Libre les ressources de rendu.
	RenderRelease();

	return (0);
}



